unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, TATools, TASeries, TAGraph, StdCtrls, ExtCtrls,
  ComCtrls, Forms, Controls, Graphics, Dialogs, types;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1:TChart;
    Chart1LineSeries1:TLineSeries;
    Chart1LineSeries2:TLineSeries;
    ChartToolset1:TChartToolset;
    ChartToolset1DataPointCrosshairTool1:TDataPointCrosshairTool;
    ChartToolset1DataPointHintTool1:TDataPointHintTool;
    CbHint:TCheckBox;
    CbCrosshair:TCheckBox;
    Label2:TLabel;
    Panel1:TPanel;
    procedure ChartToolset1DataPointCrosshairTool1AfterMouseUp(
      ATool:TChartTool; APoint:TPoint);
    procedure ChartToolset1DataPointCrosshairTool1Draw(
      ASender:TDataPointCrosshairTool);
    procedure ChartToolset1DataPointHintTool1Hint(ATool:TDataPointHintTool;
      const APoint:TPoint; var AHint:String);
    procedure FormCreate(Sender:TObject);
    procedure CheckboxChange(Sender:TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  TAChartUtils, TACustomSeries;

{ TForm1 }

procedure TForm1.FormCreate(Sender:TObject);
const
  N1 = 50;
  N2 = 100;
  min = -10;
  max = 10;
var
  i: Integer;
  x: double;
begin
  for i:=0 to N1-1 do begin
    x := min + (max - min)*I/(N1-1);
    Chart1LineSeries1.AddXY(x, sin(x)/x);
  end;
  for i:=0 to N2-1 do begin
    x := min + (max - min)*I/(N2-1);
    Chart1LineSeries2.AddXY(x, cos(x)*sin(2*x));
  end;
  Label2.Caption := '';
end;

procedure TForm1.CheckboxChange(Sender:TObject);
begin
  ChartToolset1DatapointHintTool1.Enabled := CbHint.Checked;
  ChartToolset1DatapointCrosshairTool1.Enabled := CbCrosshair.Checked;
  Label2.Visible := CbCrosshair.Checked;
end;

procedure TForm1.ChartToolset1DataPointCrosshairTool1AfterMouseUp(
  ATool:TChartTool; APoint:TPoint);
begin
  TDatapointCrosshairTool(ATool).Hide;
end;

procedure TForm1.ChartToolset1DataPointCrosshairTool1Draw(
  ASender:TDataPointCrosshairTool);
var
  msg : string;
  pt : TDoublePoint;
  ser : TChartSeries;
begin
  if not (ASender is TDataPointCrosshairTool) then begin
    Label2.Caption := '';
    exit;
  end;
  with TDataPointCrosshairTool(ASender) do begin
    ser := TChartSeries(Series);
    pt := NearestGraphPoint;
  end;
  if ser <> nil then
    Label2.Caption := Format('%s: x=%f, y=%f (#%d)', [ser.Title, pt.x, pt.y, TDataPointCrossHairtool(ASender).PointIndex])
  else
    Label2.Caption := '';
end;

procedure TForm1.ChartToolset1DataPointHintTool1Hint(ATool:TDataPointHintTool;
  const APoint:TPoint; var AHint:String);
var
  x,y: Double;
  series: TChartSeries;
begin
  series := TChartSeries(ATool.Series);
  if series <> nil then begin
    x := series.Listsource.Item[ATool.PointIndex]^.X;
    y := series.Listsource.Item[ATool.PointIndex]^.Y;
    AHint := Format('%s: x = %f, y = %f', [series.Title, x, y]);
  end;
end;

end.

